/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package vostokgloblibsample;

import java.util.regex.Pattern;
import org.vostok.glob.Glob;
import org.vostok.glob.PriorityGlobList;

/**
 *
 * @author levreau.jerome@vostoksystem.eu
 */
public class TestGlob {

	/**
	 * @param args the command line arguments
	 */
	public static void main(String[] args) {
		TestGlob test = new TestGlob();

		test.commonTest();
		test.priorityList();
		test.speedTest();
	}

	public TestGlob() {
	}

	public void commonTest() {
		System.out.println("\n\n----------------  common test ------------------");

		String mail = "*@vostoksystem.*";
		Glob g = Glob.compile(mail);

		String tmpA = "abc@vostoksystem.eu";
		String tmpB = "xyz@vostoksystem.com";
		String tmpC = "XYZ@VostokSystem.com";
		String tmpD = "xyz@gmail.com";

		System.out.println("is \"" + tmpA + "\" a match for pattern \"" + mail + "\" ? " + g.matches(tmpA));
		System.out.println("is \"" + tmpB + "\" a match for pattern \"" + mail + "\" ? " + g.matches(tmpB));
		System.out.println("is \"" + tmpC + "\" a match for pattern \"" + mail + "\" ? " + g.matches(tmpC));
		System.out.println("is \"" + tmpD + "\" a match for pattern \"" + mail + "\" ? " + g.matches(tmpD));

	}

	public void priorityList() {
		System.out.println("\n\n----------------  using PriorityGlobList ------------------");
		PriorityGlobList pl = new PriorityGlobList();
		pl.add(PriorityGlobList.createEntry("matroska", "*.mkv"));
		pl.add(PriorityGlobList.createEntry("audio video interlave", "*.avi"));
		pl.add(PriorityGlobList.createEntry("mpeg-4", "*.mp4"));

		String tmpA = "/media/video.foo.mkv";
		String tmpB = "Other.mp4";
		String tmpC = "some music.mp3";
		String tmpD = "A movie.avi";

		System.out.println("is \"" + tmpA + "\" a video ? " + (pl.matchfile(tmpA) != null));
		System.out.println("is \"" + tmpB + "\" a video ? " + (pl.matchfile(tmpB) != null));
		System.out.println("is \"" + tmpC + "\" a video ? " + (pl.matchfile(tmpC) != null));
		System.out.println("is \"" + tmpD + "\" a video ? " + (pl.matchfile(tmpD) != null));
		System.out.println("------");

		System.out.println("Which kind of codec is " + tmpA + " ? " + pl.matchfile(tmpA).getKey());
	}

	public void speedTest() {
		System.out.println("\n\n----------------  speed test comparaison bewteen glog and matcher ------------------");
		System.out.println("\n\n(Note this test is really primitive and need more accurate mesure)");

		String source = "rt.jar";
		String gpattern = "r*.jar";
		Glob g = Glob.compile(gpattern);

		String mpattern = "^r.*\\.jar$";
		Pattern p = Pattern.compile(mpattern);

		long loop = 1000000;

		long start;
		long end;

		System.out.println("looping " + loop + " times using  Matcher for file name matching pattern over " + source + " en pattern " + mpattern + " (jar files starting with and r)...");
		start = System.nanoTime();
		for (long i = 0; i < loop; i++) {
			p.matcher(source).matches();
		}
		end = System.nanoTime();
		System.out.println("... time : " + (end - start) + " (" + ((end - start) / loop) + " ns average )");

		System.out.println("looping " + loop + " times using  glob for file name matching pattern over " + source + " en pattern " + gpattern + " (jar files starting with and r)...");
		start = System.nanoTime();
		for (long i = 0; i < loop; i++) {
			g.matches(source);
		}
		end = System.nanoTime();
		System.out.println("... time : " + (end - start) + " (" + ((end - start) / loop) + " ns average )");
	}
}
